]> arthur.barton.de Git - bup.git/blob - Makefile
Update base_version to 0.34~ for 0.34 development
[bup.git] / Makefile
1
2 SHELL := bash
3 .DEFAULT_GOAL := all
4
5 # See config/config.vars.in (sets bup_python, among other things)
6 include config/config.vars
7
8 pf := set -o pipefail
9
10 define isok
11   && echo " ok" || echo " no"
12 endef
13
14 # If ok, strip trailing " ok" and return the output, otherwise, error
15 define shout
16 $(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
17 endef
18
19 sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
20 sampledata_rev := \
21   $(call shout,$(sampledata_rev),Could not parse sampledata revision)
22
23 current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)
24
25 os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
26 os := $(call shout,$(os),Unable to determine OS)
27
28 CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
29 CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
30 SOEXT:=.so
31
32 ifeq ($(os),CYGWIN)
33   SOEXT:=.dll
34 endif
35
36 ifdef TMPDIR
37   test_tmp := $(TMPDIR)
38 else
39   test_tmp := $(CURDIR)/t/tmp
40 endif
41
42 initial_setup := $(shell ./configure-version --update $(isok))
43 initial_setup := $(call shout,$(initial_setup),Version configuration failed))
44
45 config/config.vars: configure config/configure config/configure.inc \
46   $(wildcard config/*.in)
47         MAKE="$(MAKE)" ./configure
48
49 bup_cmds := cmd/bup-python\
50   $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
51   $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
52
53 bup_deps := bup lib/bup/_checkout.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
54
55 all: $(bup_deps) Documentation/all $(current_sampledata)
56
57 bup:
58         ln -s main.py bup
59
60 $(current_sampledata):
61         t/configure-sampledata --setup
62
63 define install-python-bin
64   set -e; \
65   sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
66   chmod 0755 $2;
67 endef
68
69 PANDOC ?= $(shell type -p pandoc)
70
71 ifeq (,$(PANDOC))
72   $(shell echo "Warning: pandoc not found; skipping manpage generation" 1>&2)
73   man_md :=
74 else
75   man_md := $(wildcard Documentation/*.md)
76 endif
77
78 man_roff := $(patsubst %.md,%.1,$(man_md))
79 man_html := $(patsubst %.md,%.html,$(man_md))
80
81 INSTALL=install
82 PREFIX=/usr/local
83 MANDIR=$(PREFIX)/share/man
84 DOCDIR=$(PREFIX)/share/doc/bup
85 BINDIR=$(PREFIX)/bin
86 LIBDIR=$(PREFIX)/lib/bup
87
88 dest_mandir := $(DESTDIR)$(MANDIR)
89 dest_docdir := $(DESTDIR)$(DOCDIR)
90 dest_bindir := $(DESTDIR)$(BINDIR)
91 dest_libdir := $(DESTDIR)$(LIBDIR)
92
93 install: all
94         $(INSTALL) -d $(dest_bindir) \
95                 $(dest_libdir)/bup $(dest_libdir)/cmd \
96                 $(dest_libdir)/web $(dest_libdir)/web/static
97         test -z "$(man_roff)" || install -d $(dest_mandir)/man1
98         test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(dest_mandir)/man1
99         test -z "$(man_html)" || install -d $(dest_docdir)
100         test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(dest_docdir)
101         $(call install-python-bin,bup,"$(dest_bindir)/bup")
102         set -e; \
103         for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
104           $(call install-python-bin,"$$cmd","$(dest_libdir)/$$cmd") \
105         done
106         $(INSTALL) -pm 0644 \
107                 lib/bup/*.py \
108                 $(dest_libdir)/bup
109         $(INSTALL) -pm 0755 \
110                 lib/bup/*$(SOEXT) \
111                 $(dest_libdir)/bup
112         $(INSTALL) -pm 0644 \
113                 lib/web/static/* \
114                 $(dest_libdir)/web/static/
115         $(INSTALL) -pm 0644 \
116                 lib/web/*.html \
117                 $(dest_libdir)/web/
118
119 config/config.h: config/config.vars
120
121 lib/bup/_helpers$(SOEXT): \
122                 config/config.h \
123                 lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
124         @rm -f $@
125         cd lib/bup && \
126         LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" "$(bup_python)" csetup.py build
127         # Make sure there's just the one file we expect before we copy it.
128         "$(bup_python)" -c \
129           "import glob; assert(len(glob.glob('lib/bup/build/*/_helpers*$(SOEXT)')) == 1)"
130         cp lib/bup/build/*/_helpers*$(SOEXT) "$@"
131
132 lib/bup/_checkout.py:
133         @if grep -F '$Format' lib/bup/_release.py \
134             && ! test -e lib/bup/_checkout.py; then \
135           echo "Something has gone wrong; $@ should already exist."; \
136           echo 'Check "./configure-version --update"'; \
137           false; \
138         fi
139
140 t/tmp:
141         mkdir t/tmp
142
143 runtests: runtests-python runtests-cmdline
144
145 # The "pwd -P" here may not be appropriate in the long run, but we
146 # need it until we settle the relevant drecurse/exclusion questions:
147 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
148 runtests-python: all t/tmp
149         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
150           "$(bup_python)" wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
151             | tee -a t/tmp/test-log/$$$$.log
152
153 cmdline_tests := \
154   t/test-ftp \
155   t/test-save-restore \
156   t/test-packsizelimit \
157   t/test-prune-older \
158   t/test-web.sh \
159   t/test-rm.sh \
160   t/test-gc.sh \
161   t/test-main.sh \
162   t/test-list-idx.sh \
163   t/test-index.sh \
164   t/test-split-join.sh \
165   t/test-fuse.sh \
166   t/test-drecurse.sh \
167   t/test-cat-file.sh \
168   t/test-compression.sh \
169   t/test-fsck.sh \
170   t/test-index-clear.sh \
171   t/test-index-check-device.sh \
172   t/test-ls \
173   t/test-ls-remote \
174   t/test-tz.sh \
175   t/test-meta.sh \
176   t/test-on.sh \
177   t/test-restore-map-owner.sh \
178   t/test-restore-single-file.sh \
179   t/test-rm-between-index-and-save.sh \
180   t/test-save-with-valid-parent.sh \
181   t/test-sparse-files.sh \
182   t/test-command-without-init-fails.sh \
183   t/test-redundant-saves.sh \
184   t/test-save-creates-no-unrefs.sh \
185   t/test-save-restore-excludes.sh \
186   t/test-save-strip-graft.sh \
187   t/test-import-duplicity.sh \
188   t/test-import-rdiff-backup.sh \
189   t/test-xdev.sh \
190   t/test.sh
191
192 tmp-target-run-test-get-%: all t/tmp
193         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
194           t/test-get $* 2>&1 | tee -a t/tmp/test-log/$$$$.log
195
196 test_get_targets := \
197   tmp-target-run-test-get-replace \
198   tmp-target-run-test-get-universal \
199   tmp-target-run-test-get-ff \
200   tmp-target-run-test-get-append \
201   tmp-target-run-test-get-pick \
202   tmp-target-run-test-get-new-tag \
203   tmp-target-run-test-get-unnamed
204
205 # For parallel runs.
206 # The "pwd -P" here may not be appropriate in the long run, but we
207 # need it until we settle the relevant drecurse/exclusion questions:
208 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
209 tmp-target-run-test%: all t/tmp
210         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
211           t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
212
213 runtests-cmdline: $(test_get_targets) $(subst t/test,tmp-target-run-test,$(cmdline_tests))
214
215 stupid:
216         PATH=/bin:/usr/bin $(MAKE) test
217
218 test: all
219         if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
220         mkdir -p t/tmp/test-log
221         ./wvtest watch --no-counts \
222           $(MAKE) runtests-python runtests-cmdline 2>t/tmp/test-log/$$$$.log
223         ./wvtest report t/tmp/test-log/*.log
224
225 check: test
226
227 distcheck: all
228         ./wvtest run t/test-release-archive.sh
229
230 cmd/python-cmd.sh: config/config.vars Makefile
231         printf "#!/bin/sh\nexec %q \"\$$@\"" "$(bup_python)" \
232           >> cmd/python-cmd.sh.$$PPID.tmp
233         chmod +x cmd/python-cmd.sh.$$PPID.tmp
234         mv cmd/python-cmd.sh.$$PPID.tmp cmd/python-cmd.sh
235
236 long-test: export BUP_TEST_LEVEL=11
237 long-test: test
238
239 long-check: export BUP_TEST_LEVEL=11
240 long-check: check
241
242 cmd/bup-%: cmd/%-cmd.py
243         rm -f $@
244         ln -s $*-cmd.py $@
245
246 cmd/bup-%: cmd/%-cmd.sh
247         rm -f $@
248         ln -s $*-cmd.sh $@
249
250 .PHONY: Documentation/all
251 Documentation/all: $(man_roff) $(man_html)
252
253 Documentation/substvars: $(bup_deps)
254         echo "s,%BUP_VERSION%,$$(./bup version --tag),g" > $@
255         echo "s,%BUP_DATE%,$$(./bup version --date),g" >> $@
256
257 Documentation/%.1: Documentation/%.md Documentation/substvars
258         $(pf); sed -f Documentation/substvars $< \
259           | $(PANDOC) -s -r markdown -w man -o $@
260
261 Documentation/%.html: Documentation/%.md Documentation/substvars
262         $(pf); sed -f Documentation/substvars $< \
263           | $(PANDOC) -s -r markdown -w html -o $@
264
265 .PHONY: Documentation/clean
266 Documentation/clean:
267         cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars
268
269 # Note: this adds commits containing the current manpages in roff and
270 # html format to the man and html branches respectively.  The version
271 # is determined by "git describe --always".
272 .PHONY: update-doc-branches
273 update-doc-branches: Documentation/all
274         dev/update-doc-branches refs/heads/man refs/heads/html
275
276 # push the pregenerated doc files to origin/man and origin/html
277 push-docs: export-docs
278         git push origin man html
279
280 # import pregenerated doc files from origin/man and origin/html, in case you
281 # don't have pandoc but still want to be able to install the docs.
282 import-docs: Documentation/clean
283         $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
284         $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
285
286 clean: Documentation/clean cmd/bup-python
287         cd config && rm -f *~ .*~ \
288           ${CONFIGURE_DETRITUS} ${CONFIGURE_FILES} ${GENERATED_FILES}
289         rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
290                 .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
291                 *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
292                 bup bup-* \
293                 randomgen memtest \
294                 testfs.img lib/bup/t/testfs.img
295         if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
296         if test -e t/mnt; then rm -r t/mnt; fi
297         if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
298         # FIXME: migrate these to t/mnt/
299         if test -e lib/bup/t/testfs; \
300           then umount lib/bup/t/testfs || true; fi
301         rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
302         if test -e t/tmp; then t/force-delete t/tmp; fi
303         ./configure-version --clean
304         t/configure-sampledata --clean
305         # Remove last so that cleanup tools can depend on it
306         rm -f cmd/bup-* cmd/python-cmd.sh